=== debian/changelog ===
librabbitmq (0.15.0-1build1) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 05 Sep 2025 19:20:12 +0000

librabbitmq (0.15.0-1) unstable; urgency=medium

  * [0dd9015] New upstream version 0.15.0
  * [b7ed3ad] d/patches/: remove as all are now applied upstream
  * [76213b0] d/librabbitmq4.symbols: update for new upstream version

 -- Florian Ernst <florian@debian.org>  Fri, 22 Nov 2024 14:21:29 +0100
