=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/librabbitmq-c-$1.tar.gz/ \
https://github.com/alanxz/rabbitmq-c/tags .*/v?(\d.*)@ARCHIVE_EXT@
